;  File:[22,310]P3UTIL.MOD      Last edit: 18-SEP-1989 15:31:31 
;
;  Author: Phil Hannay
;  History: Phil Hannay 19-Oct-83 Creation
;           Phil Hannay 23-Nov-83 Added many more P3UTIL modules
;	    JMB 2-Dec-83 -- correct library name
;           Phil Hannay 14-Dec-83 Added USTP module
;	    JMB 24-JAN-84 -- Append contents of P3MAC.MOD
;	    JMB 26-Jan-84 -- insert SPAD, SSEARCH
;           MRC 14-Aug-84 -- insert STRUNC, SCHCONCAT, SUPPER,
;           MRC 15-Aug-84 -- insert SNICE
;           Phil Hannay  1-Aug-85 -- insert QIOWRP
;           Phil Hannay 19-Jan-87  Added CASTIN, LOCK, UNLOCK
;           Phil Hannay 10-Feb-87.  Added some orphans - SPAWN,
;              RPOI, DIGITS, SVASSIGN.  Commented out SNICE - I could
;              not find the source - moved EXT to [22,310]
;           Phil Hannay.  12-Feb-87.  Commented out USRPMA - does not
;              work with V2.1E.
;           Phil Hannay.  22-May-87.  Added GMCR - null source generates
;              EXT file, but no code since GMCR is supplied in PA3LIB by 
;              Oregon Software.
;	    Bob Thomas 9-Jun-87 -- Added CADTND - convert Ascii date to numeric
;	       and CNDTAD - convert numeric date to Ascii date.
;	    Bob Thomas 10-Jun-87 -- Added CDATE - compress Ascii date and
;	       UCDATE - Uncompress Ascii date.
;           Phil Hannay.  24-Aug-87.  Added QIO (QIO no wait).
;           Phil Hannay.  26-Aug-87.  Added SRDA - Recv data packet AST
;           Phil Hannay.  27-Oct-87.  Added STLO - stop for logical OR of efn
;           Phil Hannay.  13-Apr-88.  Added VRCSPA, VRCDPA, VRDAPA - variable
;              send/receive routines written by Pete in Reserve.
;           Phil Hannay.  15-Apr-88.  Added VRCD, VSDA, SREAD, SWRITE, SADR
;              send/receive and address routines.
;           Phil Hannay.  16-Sep-88.  Added CPKTAS, RLON, TLON, CLON, DLON
;              convert packed decimal to ascii, and translate logicals routines.
;           Phil Hannay.  6-Apr-89.  Added new QIO, QIOW, dropped QIOWRP.
;              Added SNDMSG, RCVMSG, CPITAS, CPSTAS, XXSLEN.
;           Phil Hannay.  9-May-89.  Added CASTRE and CNCT.
;           Phil Hannay.  19-Jun-89.  Added VIEWPROC, DECL, UNSLCT and TYPBUF
;           Phil Hannay.  21-Jun-89.  Added CRETAS.
;           Phil Hannay.  7-Sep-89.  Added GTIM.
;
;
;  This is the MOD file used to create the [22,310]P3UTIL.OLB Pascal V2.1
;   utility library (via @BUILDLBR) and to extract the EXT files for
;   all Pascal callable entry points in each module (via @BUILDEXT).
;   Note that the headers to be extracted for each entry point
;   is indicated by a percent sign (%).  These headers will be placed 
;   in the device and uic specified.  The library name where 
;   the object modules are to be placed is the first non-commented line.
;   If a library is not found, the command file will abort.  Action
;   will be logged on the log file P3UTIL.LOG.
;
;  Comment lines are those with a semi-colon or <CR> in the first column.
;   All other lines are considered valid input lines.
;
;
;  Here is the library file spec line:

[22,310]P3UTIL


;  And here are the modules and their entry points:

; The OMSI string handling package with Grain Lab modifications...

[22,310]SADR.PAS
%[22,320]SADR

[22,310]SLEN.PAS
%[22,320]SLEN

[22,310]SASSIGN.PAS
%[22,320]SASSIGN
%[22,320]SCHASSIGN

[22,310]SCLEAR.PAS
%[22,320]SCLEAR

[22,310]SCONCAT.PAS
%[22,320]SCONCAT

[22,310]SDELETE.PAS
%[22,320]SDELETE

[22,310]SEQUAL.PAS
%[22,320]SEQUAL

[22,310]SINSERT.PAS
%[22,320]SINSERT

[22,310]SREAD.PAS
%[22,320]SREAD

[22,310]SRECV.PAS
%[22,320]SRECV

[22,310]SSEND.PAS
%[22,320]SSEND

[22,310]SWRITE.PAS
%[22,320]SWRITE

[22,310]SSUBSTR.PAS
%[22,320]SSUBSTR

[22,310]SPAD.PAS
%[22,320]SPAD

[22,310]SSEARCH.PAS
%[22,320]SSEARCH

[22,310]STRUNC.PAS
%[22,320]STRUNC

[22,310]SCHCONCAT.PAS
%[22,320]SCHCONCAT

[22,310]SUPPER.PAS
%[22,320]SUPPER

[22,310]SVASSIGN.PAS
%[22,320]SVASSIGN

; cannot find SNICE.PAS - what happened to it?
;[22,310]SNICE.PAS
;%[22,320]SNICE

; end of string package 


[22,310]ATTESQ.MAC
%[22,320]ATTESQ

; return current date or time or both in an ascii format
[22,310]ADATIM.MAC
%[22,320]ADATIM

; convert an Ascii date to a numeric date
[22,310]CADTND.PAS
%[22,320]CADTND

; convert a numeric date to an Ascii date
[22,310]CNDTAD.PAS
%[22,320]CNDTAD

; compress an Ascii date
[22,310]CDATE.PAS
%[22,320]CDATE

; uncompress an Ascii date
[22,310]UCDATE.PAS
%[22,320]UCDATE

; assign a lun
[22,310]ALUN.MAC
%[22,320]ALUN

; clear an event flag
[22,310]CLEF.MAC
%[22,320]CLEF

; cancel pending mark time(s)
[22,310]CMKT.MAC
%[22,320]CMKT

; convert a 3 word ascii string to a 2 word RAD50 string
[22,310]CATR56.MAC
%[22,320]CATR56

; convert a 2 word RAD50 string to a 3 word ascii string
[22,310]CR56TA.MAC
%[22,320]CR56TA

; declare significant event
[22,310]DECL.MAC
%[22,320]DECL

; Get the run time command line, load into INPUT so user can do READLN
;   (No code in object module, code in PA3LIB.  Just here for the EXT file)
[22,310]GMCR.MAC
%[22,320]GMCR

; Send or Receive message packets, translate packet ids and sub types
[22,310]MSGPACKET.PAS
%[22,320]MSGLEN
%[22,320]SNDMSG
%[22,320]RCVMSG
%[22,320]CPITAS
%[22,320]CPSTAS

; Set a mark time and set an event flag or do an AST upon expiration of time
[22,310]MRKT.MAC
%[22,320]MRKT

; QIO no wait - directive
[22,310]QIO.MAC
%[22,320]QIO

; QIO wait - directive
[22,310]QIOW.MAC
%[22,320]QIOW

[22,310]RCST.MAC
%[22,320]RCST

; Receive a fixed length message packet
[22,310]RCVD.MAC
%[22,320]RCVD

[22,310]RDAF.MAC
%[22,320]RDAF

[22,310]RDXF.MAC
%[22,320]RDXF

; Send a fixed length message packet
[22,310]SDAT.MAC
%[22,320]SDAT

; Set an event flag
[22,310]SETF.MAC
%[22,320]SETF

; Set an event flag when a message packet is queued for task - uses a
; restricted application of the Receive Data AST service
[22,310]SRDA.MAC
%[22,320]SRDA

; Stop for logical OR of event flags
[22,310]STLO.MAC
%[22,320]STLO

; Stop a task
[22,310]STOP.MAC
%[22,320]STOP

; Stop for a single event flag
[22,310]STSE.MAC
%[22,320]STSE

;[22,310]USRPMA.MAC
;%[22,320]USRPMA

; Unstop a task
[22,310]USTP.MAC
%[22,320]USTP

; VIEWPORT interface 
[22,310]VIEWPROC.PAS
%[22,320]Vastat
%[22,320]Vcheck
%[22,320]Vdjob
%[22,320]Vput
%[22,320]Vget
%[22,320]Vecho
%[22,320]Vinit
%[22,320]Vrecv
%[22,320]Vsend
%[22,320]Vown
%[22,320]Vdisc
%[22,320]Vreset
%[22,320]Vcon

; Wait for a single event flag
[22,310]WTSE.MAC
%[22,320]WTSE

; Convert an ascii string to a BCD word
[22,310]CASTBC.PAS
%[22,320]CASTBC

; Convert a BCD word to an ascii string
[22,310]CBCTAS.PAS
%[22,320]CBCTAS

; Convert a BCD word to a binary word
[22,310]CBCTWO.PAS
%[22,320]CBCTWO

; Convert an ascii string to a word
[22,310]CASTWO.PAS
%[22,320]CASTWO

; Convert a word to an ascii string
[22,310]CWOTAS.PAS
%[22,320]CWOTAS

; Convert an ascii string to an integer
; CASTIN.PAS needs CASTWO.EXT, so CASTWO must precede CASTIN.PAS
[22,310]CASTIN.PAS
%[22,320]CASTIN

; Convert an integer to an ascii string
[22,310]CINTAS.PAS
%[22,320]CINTAS

; Convert packed decimal string to an ascii string
[22,310]CPKTAS.PAS
%[22,320]CPKTAS

; Convert ascii string to a real number
[22,310]CASTRE.PAS
%[22,320]CASTRE

; Convert a real number to an ascii string
[22,310]CRETAS.PAS
%[22,320]CRETAS

; Translate logicals - RLON, TLON, CLON, DLON
[22,310]RLON.MAC
%[22,320]RLON
%[22,320]TLON

[22,310]CLON.MAC
%[22,320]CLON

[22,310]DLON.MAC
%[22,320]DLON

; Internal string length routine used by RLON,TLON
[22,310]XXSLEN.MAC

; CNCT$ connect directive
[22,310]CNCT.MAC
%[22,320]CNCT

; Directive error handler routine
[22,310]DIRERR.PAS
%[22,320]DIRERR

[22,310]ERROR.PAS
%[22,320]ERROR

[22,310]EXST.PAS
%[22,320]EXST

; Lock a resource for exclusive use
[22,310]LOCK.MAC
%[22,320]LOCK

; Unlock a locked resource
[22,310]UNLOCK.MAC
%[22,320]UNLOCK

[22,310]GETADR.PAS
%[22,320]GETADR

[22,310]PUTSTR.PAS
%[22,320]PUTSTR

[22,310]QIOERR.PAS
%[22,320]QIOERR

[22,310]RDEF.PAS
%[22,320]RDEF

; Wait a specified time interval - use STOP state
[22,310]WAIT.PAS
%[22,320]WAIT

; Wait a specified time interval - use WAIT state
[22,310]WAITW.PAS
%[22,320]WAITW

[22,310]XORW.PAS
%[22,320]XORW

[22,310]ABORT.PAS
%[22,320]ABORT

; GTSK$ get task info directive
[22,310]GTSK.MAC
%[22,320]GTSK

; GTIM$ get time/date directive
[22,310]GTIM.MAC
%[22,320]GTIM

[22,310]RPOI.MAC
%[22,320]RPOI

[22,310]SPAWN.MAC
%[22,320]SPAWN

[22,310]DIGITS.PAS
%[22,320]DIGITS

; Return the current character count of the type ahead buffer
[22,310]TYPBUF.MAC
%[22,320]TYPBUF

; Set up one or more LUNS for unsolicted input notification ASTs
[22,310]UNSLCT.MAC
%[22,320]UNSLCT

; Variable receive data - Mplus only
[22,310]VRCDPA.MAC
%[22,320]VRCDPA

; Variable receive data or stop - Mplus only
[22,310]VRCSPA.MAC
%[22,320]VRCSPA

; Variable send data - Mplus only
[22,310]VSDAPA.MAC
%[22,320]VSDAPA

; Variable send data - Mplus only
[22,310]VSDA.MAC
%[22,320]VSDA

; Variable receive data - Mplus only
[22,310]VRCD.MAC
%[22,320]VRCD

;
; 
;
; End of the file
;
